--
-- CREATE_TYPE and DROP TYPE
--

CREATE TYPE ct1 (
   internallength = 24, 
   input = widget_in,
   output = widget_out,
   alignment = double,
   storage = plain
);

CREATE TYPE ct2 ( 
   internallength = variable, 
   input = int44in, 
   output = int44out, 
   element = int4,
   storage = external
);

CREATE TYPE ct3 ( 
   internallength = variable, 
   input = int44in, 
   output = int44out, 
   element = int4,
   storage = extended
);

CREATE TYPE ct4 ( 
   internallength = variable, 
   input = int44in, 
   output = int44out, 
   element = int4,
   storage = main
);

-- this command creates the box data type and then uses the type in a table
-- definition
CREATE TYPE box2 (INTERNALLENGTH = 8,
   INPUT = widget_in, OUTPUT = widget_out );
CREATE TABLE myboxes (id INT4, description box2);

-- this command creates a variable length array type with integer elements
CREATE TYPE int4array (INPUT = int44in, OUTPUT = int44out,
   INTERNALLENGTH = VARIABLE, ELEMENT = int4 );
CREATE TABLE myarrays (id int4, numbers int4array);

-- this command creates a large object type and uses it in a table definition
CREATE TYPE bigobj (INPUT = int44in, OUTPUT = int44out,
   INTERNALLENGTH = VARIABLE);
CREATE TABLE big_objs (id int4, obj bigobj);

DROP TABLE myboxes;
DROP TABLE myarrays;
DROP TABLE big_objs;

/* add comment to the type */
COMMENT ON TYPE ct1 IS 'This is my created type 1.';
DROP TYPE ct1;
DROP TYPE ct2;
DROP TYPE ct3, ct4;
DROP TYPE box2;
DROP TYPE bigobj;
DROP TYPE int4array;

CREATE TYPE ct5 ( 
   internallength = 16, 
   input = int44in, 
   output = int44out, 
   element = int4,
   storage = external
);

